## mlgmp 20021123

=== Makefile ===
# Use GNU Make !
RANLIB= ranlib

OCAML_LIBDIR:= $(shell ocamlc -where)
GMP_INCLUDES= -I/opt/gmp/include -I/users/absint2/local/include -I$(HOME)/packages/gmp/include

GMP_LIBDIR=/opt/gmp/lib
DESTDIR= $(OCAML_LIBDIR)/gmp

RLIBFLAGS= -cclib "-Wl,-rpath $(GMP_LIBDIR)" # Linux, FreeBSD
#RLIBFLAGS= -cclib "-Wl,-R $(GMP_LIBDIR)" # Solaris
# RLIBFLAGS= # MacOS X

LIBFLAGS= -cclib -L. -cclib -L$(GMP_LIBDIR) $(RLIBFLAGS) \
	-cclib -lmpfr -cclib -lgmp -cclib -L$(DESTDIR)

CC= gcc
CFLAGS_MISC= -Wall -Wno-unused -g -O3
#CFLAGS_MISC=
CFLAGS_INCLUDE= -I $(OCAML_LIBDIR) $(GMP_INCLUDES)
CFLAGS= $(CFLAGS_MISC) $(CFLAGS_INCLUDE)

OCAMLC= ocamlc -g
OCAMLOPT= ocamlopt
OCAMLFLAGS=

CMODULES= mlgmp_z.c mlgmp_q.c mlgmp_f.c mlgmp_fr.c mlgmp_random.c mlgmp_misc.c
CMODULES_O= $(CMODULES:%.c=%.o)

LIBS= libmlgmp.a gmp.a gmp.cma gmp.cmxa gmp.cmi

PROGRAMS= test_creal test_creal.opt essai essai.opt toplevel\
	test_suite test_suite.opt
TESTS= test_suite test_suite.opt

all:	$(LIBS) tests

install: all
	-mkdir $(DESTDIR)
	cp $(LIBS) gmp.mli $(DESTDIR)

tests:	$(LIBS) $(TESTS)
	./test_suite
	./test_suite.opt

%.i: %.c
	$(CC) $(CFLAGS) -E $*.c > $*.i

%.cmo: %.ml %.cmi
	$(OCAMLC) $(OCAMLFLAGS) -c $*.ml

%.cmx: %.ml %.cmi
	$(OCAMLOPT) $(OCAMLFLAGS) -c $*.ml

%.cmo: %.ml
	$(OCAMLC) $(OCAMLFLAGS) -c $*.ml

%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLFLAGS) -c $*.ml

%.cmi: %.mli
	$(OCAMLC) $(OCAMLFLAGS) -c $*.mli

$(CMODULES_O): conversions.c config.h

libmlgmp.a: $(CMODULES_O)
	$(AR) -rc $@ $+
	$(RANLIB) $@

gmp.cma: gmp.cmo libmlgmp.a
	$(OCAMLC) $(OCAMLFLAGS) -a gmp.cmo -cclib -lmlgmp $(LIBFLAGS) -o $@

gmp.a gmp.cmxa: gmp.cmx libmlgmp.a
	$(OCAMLOPT) $(OCAMLFLAGS) -a gmp.cmx -cclib -lmlgmp  $(LIBFLAGS) -o $@

pretty_gmp.cmo: pretty_gmp.cmi gmp.cmo

toplevel: gmp.cma creal.cmo pretty_gmp.cmo install_pp.cmo creal_pp.cmo install_creal_pp.cmo
	ocamlmktop -custom $+ -o $@

essai:	gmp.cma essai.cmo
	$(OCAMLC) -custom $+ -o $@

essai.opt:	gmp.cmxa essai.cmx
	$(OCAMLOPT) $+ -o $@

test_creal:	gmp.cma creal.cmo test_creal.cmo
	$(OCAMLC) -custom $+ -o $@

test_creal.opt:	gmp.cmxa creal.cmx test_creal.cmx
	$(OCAMLOPT) $+ -o $@

test_suite:	gmp.cma test_suite.cmo
	$(OCAMLC) -custom $+ -o $@

test_suite.opt:	gmp.cmxa test_suite.cmx
	$(OCAMLOPT) $+ -o $@

clean:
	rm -f *.o *.cm* $(PROGRAMS) *.a

depend:
	ocamldep *.ml *.mli > depend

.PHONY: clean

include	depend

=== debian/changelog ===
mlgmp (20021123-21) unstable; urgency=medium

  * Team upload
  * Fix compilation with gcc-10 (Closes: #957548)
  * Remove Mike from Uploaders (Closes: #873239)
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Thu, 13 Aug 2020 07:14:02 +0200

mlgmp (20021123-20) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Update Vcs-*
  * Fix compilation with OCaml 4.08.0

  [ Rémi Vanicat ]
  * Removing myself from Uploaders

 -- Stéphane Glondu <glondu@debian.org>  Tue, 03 Sep 2019 10:40:52 +0200

mlgmp (20021123-19) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Bump debhelper compat to 10
  * Update Vcs-*

  [ Dimitri John Ledkov ]
  * Update extern declarations for [de]serialize functions to match ocaml
    4.04 definitions.

 -- Stéphane Glondu <glondu@debian.org>  Mon, 17 Jul 2017 10:22:11 +0200

mlgmp (20021123-18) unstable; urgency=low

  [ Sylvain Le Gall ]
  * Remove Sylvain Le Gall from uploaders

  [ Ralf Treinen ]
  * Remove Sven Luther from uploaders (closes: #677755)
  * Standards-Vesion 3.9.6 (no change)
  * Convert to source format 3.0 (quilt):
    - update source/format
    - drop build-dependency on dpatch
    - convert patches in debian/patches from dpatch to quilt
    - drop explicit patching in debian/rules
  * Simplify debian/rules: use dh overrides

 -- Ralf Treinen <treinen@debian.org>  Wed, 12 Aug 2015 14:05:45 +0200

mlgmp (20021123-17) unstable; urgency=low

  * debian/patches/20_mlgmp_z.dpatch: fix wrong conversion from int on
    64 bits computers (Closes: #573978).
  * Bump ocaml-nox version to (>= 3.11.1-3~) and dh-ocaml to (>= 0.9~).
  * Bump standards to 3.8.4, no changes needed.
  * Remove Zack from Uploaders (on his request).
  * Add debian/source/format (keep 1.0 for now).

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 03 Jun 2010 23:05:36 +0200

mlgmp (20021123-16) unstable; urgency=low

  [ Sylvain Le Gall ]
  * Switch to dh-ocaml 0.9
    * Use ocaml:Depends/Provides in debian/control
    * Use debian/libgmp-ocaml-dev.ocamldoc to generate documentation
      (Closes: #549844)
  * Move .../gmp/META to .../METAS/META.gmp since this is a debian
    specific META

  [ Mehdi Dogguy ]
  * Update my e-mail address

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 06 Oct 2009 18:47:11 +0200

mlgmp (20021123-15) unstable; urgency=low

  * Use new Ocaml's stdlib location
  * Move library packages to the new ocaml section
  * Add myself to uploaders
  * Bump standards to 3.8.2
  * Add a README.source
  * Generate documentation
  * Register documentation with docbase
  * Add a watch file

 -- Mehdi Dogguy <dogguy@pps.jussieu.fr>  Wed, 24 Jun 2009 21:57:04 +0200

mlgmp (20021123-14) unstable; urgency=low

  [ Mike Furr ]
  * Changed packaging to git and updated VCS field
  * Changed Maintainer to d-o-m, added self to uploaders
  * Chnaged compat file to 7
  * Bump standards to 3.8.0
  * Cleaned up rules file and added build-dep on dh-ocaml
  * Changed *.in to use new substitutation vars
  * Added Homepage
  * Install the .so file directly into the proper package tree via the
    makefile, instead of moving it there manually in rules

  [ Sylvain Le Gall ]
  * Update my email address

 -- Mike Furr <mfurr@debian.org>  Fri, 27 Feb 2009 16:28:55 -0500

mlgmp (20021123-13) unstable; urgency=medium

  [ Stefano Zacchiroli ]
  * fix vcs-svn field to point just above the debian/ dir
  * fix typo in Sylvain's name
  * bump urgency to medium for the OCaml 3.10.1 transition

  [ Stephane Glondu ]
  * Fix binNMU safety (Closes: #464312)
  * Fix OCaml spelling in description
  * Fix copyright file
  * Use ${binary:Version} instead of deprecated ${Source-Version} in
    debian/control
  * Add Section:libs for source package
  * Add descriptions to patches
  * Fix lintian debian-rules-ignores-make-clean-error
  * Removing empty stublibs directory from -dev package
  * Update Standards-Version to 3.7.3

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 02 Mar 2008 15:24:05 +0100

mlgmp (20021123-12) unstable; urgency=low

  * Rebuild with 3.10.0 (Closes: #441187)

 -- Mike Furr <mfurr@debian.org>  Fri, 07 Sep 2007 17:05:56 -0400

mlgmp (20021123-11) unstable; urgency=low

  * Standards-Version 3.7.2 (no change)
  * Rebuild with Ocaml 3.09.2 (closes: Bug#369711)
  * Package description: replaced "O'Caml" by "OCaml"
  * debian/rules: changed name of the target "transition" into "debian/control"

 -- Ralf Treinen <treinen@debian.org>  Wed,  7 Jun 2006 22:24:56 +0200

mlgmp (20021123-10) unstable; urgency=low

  * Remove hard-coded ABI version
  * Rebuild with 3.09.1

 -- Mike Furr <mfurr@debian.org>  Sat,  7 Jan 2006 18:04:32 -0500

mlgmp (20021123-9) unstable; urgency=low

  * Rebuild with 3.09

 -- Mike Furr <mfurr@debian.org>  Tue,  8 Nov 2005 22:29:07 -0500

mlgmp (20021123-8) unstable; urgency=low

  * Moved the binary packages into their proper sections of
    libs && libdevel

 -- Mike Furr <mfurr@debian.org>  Mon,  5 Sep 2005 12:07:48 -0400

mlgmp (20021123-7) unstable; urgency=low

  * Use -O2 instead of -O3 to hopefully avoid an ICE on m68k
  * Several bug fixes from Pascal Zimmer including
    - Z2.copy is really Z.copy
    - Added a real Z2.copy
    - _mlgmp_z2_from_[int|string_base|float] now use mpz_set
      insetad of mpz_init_set
    - Added test suite for these functions

 -- Mike Furr <mfurr@debian.org>  Sat,  3 Sep 2005 15:11:10 -0400

mlgmp (20021123-6) unstable; urgency=low

  * Rebuild against new gmp package.

 -- Mike Furr <mfurr@debian.org>  Fri, 29 Jul 2005 12:31:36 -0400

mlgmp (20021123-5) unstable; urgency=medium

  * Rebuild against 3.08.3
  * Set [Build-]Depends to 3.08.3

 -- Mike Furr <mfurr@debian.org>  Wed, 23 Mar 2005 12:54:24 -0500

mlgmp (20021123-4) unstable; urgency=low

  * Rebuild with ocaml 3.08
  * Change deps to use ocaml-nox-3.08

 -- Mike Furr <mfurr@debian.org>  Thu, 22 Jul 2004 13:10:24 -0400



=== debian/control ===
Source: mlgmp
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
  Ralf Treinen <treinen@debian.org>,
  Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
  ocaml-nox,
  debhelper-compat (= 13),
  libgmp3-dev,
  libmpfr-dev,
  dh-ocaml
Homepage: http://www-verimag.imag.fr/~monniaux/download/
Standards-Version: 4.5.0
Rules-Requires-Root: no
Section: ocaml
Vcs-Git: https://salsa.debian.org/ocaml-team/mlgmp.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/mlgmp

Package: libgmp-ocaml
Architecture: any
Depends:
  ${shlibs:Depends},
  ${misc:Depends},
  ${ocaml:Depends}
Provides: ${ocaml:Provides}
Description: OCaml bindings for the GNU multiprecision arithmetic library (runtime)
 This package provides bindings for the GNU multiprecision library
 (GNU MP) for the language OCaml (caml.inria.fr).  It is mostly a 1-1 mapping
 of the C functions into the OCaml namespace, but also includes some
 infix operators to make for a cleaner syntax.
 .
 This package provides the shared library for running applications linked
 against libgmp-ocaml

Package: libgmp-ocaml-dev
Architecture: any
Depends:
  ${ocaml:Depends},
  libgmp3-dev,
  ${misc:Depends}
Recommends: ocaml-findlib
Provides: ${ocaml:Provides}
Description: OCaml bindings for the GNU multiprecision arithmetic library (dev)
 This package provides bindings for the GNU multiprecision library
 (GNU MP) for the language OCaml(caml.inria.fr).  It is mostly a 1-1 mapping
 of the C functions into the OCaml namespace, but also includes some
 infix operators to make for a cleaner syntax.
 .
 This package provides the static library, OCaml library and interface
 for developing applications to use libgmp-ocaml

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE=libgmp-ocaml

include /usr/share/ocaml/ocamlvars.mk

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
HAS_OPT="HAS_OPT=1"
else
HAS_OPT=
endif
%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE) depend
	$(MAKE) $(HAS_OPT)

override_dh_auto_install:
	$(MAKE) $(HAS_OPT) install \
	      DESTDIR=$(CURDIR)/debian/$(PACKAGE)-dev \
	      STUBDIR=$(CURDIR)/debian/$(PACKAGE)/$(OCAML_DLL_DIR)
